var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    var _a, _b, _c, _d;
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.getHTML = getHTML;
    exports.attachDeclarativeShadowRoots = attachDeclarativeShadowRoots;
    exports.setHTMLUnsafe = setHTMLUnsafe;
    exports.parseHTMLUnsafe = parseHTMLUnsafe;
    var xmlSerializer = new XMLSerializer(), attachShadow = HTMLElement.prototype.attachShadow, shadowDOMs = new WeakMap();
    HTMLElement.prototype.attachShadow = function (options) {
        var shadowRoot = attachShadow.call(this, options);
        shadowDOMs.set(this, shadowRoot);
        return shadowRoot;
    };
    /**
     * @see {@link https://developer.mozilla.org/en-US/docs/Web/API/Element/getHTML}
     * @see {@link https://developer.mozilla.org/en-US/docs/Web/API/ShadowRoot/getHTML}
     */
    function getHTML(_a) {
        var _this = this;
        var _b = _a === void 0 ? {} : _a, serializableShadowRoots = _b.serializableShadowRoots, shadowRoots = _b.shadowRoots;
        shadowRoots = (shadowRoots === null || shadowRoots === void 0 ? void 0 : shadowRoots.filter(Boolean)) || [];
        if (!serializableShadowRoots || !shadowRoots[0])
            return this.innerHTML;
        var walker = document.createTreeWalker(this, NodeFilter.SHOW_ALL, {
            acceptNode: function (node) {
                return node === _this || node instanceof SVGElement
                    ? NodeFilter.FILTER_SKIP
                    : NodeFilter.FILTER_ACCEPT;
            }
        }), markup = [];
        var currentNode = null;
        while ((currentNode = walker.nextNode())) {
            if (currentNode instanceof CDATASection)
                markup.push("<![CDATA[".concat(currentNode.nodeValue, "]]>"));
            else if (currentNode instanceof Text)
                markup.push(currentNode.nodeValue || "");
            else if (currentNode instanceof Comment)
                markup.push("<!--".concat(currentNode.nodeValue, "-->"));
            else if (currentNode instanceof SVGElement)
                markup.push(xmlSerializer.serializeToString(currentNode));
            else if (currentNode instanceof Element) {
                var tagName = currentNode.tagName.toLowerCase(), attributes = __spreadArray([], __read(currentNode.attributes), false).map(function (_a) {
                    var name = _a.name, value = _a.value;
                    return "".concat(name, "=").concat(JSON.parse(value));
                }), shadowRoot = shadowDOMs.get(currentNode);
                markup.push("<".concat(__spreadArray([tagName], __read(attributes), false).join(" "), ">"));
                if (shadowRoots.includes(shadowRoot))
                    markup.push("<template shadowrootmode=\"".concat(shadowRoot.mode, "\">").concat(getHTML.call(shadowRoot, { serializableShadowRoots: serializableShadowRoots, shadowRoot: shadowRoot }), "</template>"));
            }
            var nextSibling = currentNode.nextSibling, parentElement = currentNode.parentElement;
            if (!nextSibling &&
                parentElement &&
                parentElement !== this &&
                this.contains(parentElement))
                markup.push("</".concat(parentElement.tagName.toLowerCase(), ">"));
        }
        return markup.join("");
    }
    function attachDeclarativeShadowRoots(root) {
        var e_1, _a;
        var templates = root.querySelectorAll("template[shadowrootmode]");
        try {
            for (var templates_1 = __values(templates), templates_1_1 = templates_1.next(); !templates_1_1.done; templates_1_1 = templates_1.next()) {
                var template = templates_1_1.value;
                var parentElement = template.parentElement, content = template.content;
                var shadowRoot = parentElement.attachShadow({
                    // @ts-ignore
                    mode: template.getAttribute("shadowrootmode")
                });
                shadowRoot.append(content);
                template.remove();
                attachDeclarativeShadowRoots(shadowRoot);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (templates_1_1 && !templates_1_1.done && (_a = templates_1.return)) _a.call(templates_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    }
    /**
     * @see {@link https://developer.mozilla.org/en-US/docs/Web/API/Element/setHTMLUnsafe}
     * @see {@link https://developer.mozilla.org/en-US/docs/Web/API/ShadowRoot/setHTMLUnsafe}
     */
    function setHTMLUnsafe(html) {
        this.innerHTML = html;
        attachDeclarativeShadowRoots(this);
    }
    var domParser = new DOMParser(), initDocument = function (_a) {
        var _b = _a === void 0 ? document : _a, documentElement = _b.documentElement;
        return attachDeclarativeShadowRoots(documentElement);
    };
    /**
     * @see {@link https://developer.mozilla.org/en-US/docs/Web/API/Document/parseHTMLUnsafe_static}
     */
    function parseHTMLUnsafe(html) {
        var document = domParser.parseFromString(html, "text/html");
        initDocument(document);
        return document;
    }
    (_a = Element.prototype).getHTML || (_a.getHTML = getHTML);
    (_b = Element.prototype).setHTMLUnsafe || (_b.setHTMLUnsafe = setHTMLUnsafe);
    (_c = ShadowRoot.prototype).getHTML || (_c.getHTML = getHTML);
    (_d = ShadowRoot.prototype).setHTMLUnsafe || (_d.setHTMLUnsafe = setHTMLUnsafe);
    Document["parseHTMLUnsafe"] || (Document["parseHTMLUnsafe"] = parseHTMLUnsafe);
    new Promise(function (resolve) {
        if (document.readyState === "complete")
            resolve();
        else {
            document.addEventListener("DOMContentLoaded", resolve);
            window.addEventListener("load", resolve);
        }
    }).then(function () { return initDocument(); });
});
//# sourceMappingURL=index.js.map